#include "s2.h"
#include <time.h>

#define SEARCH_MIN_ITER 1000
#define GRAD_NORM 1e-5

int Verbose=0;
int main(int argc,char *argv[])
{
extern double g_y1;
extern double g_y2;
extern double g_y3;
extern double g_x11;
extern double g_x12;
extern double g_x13;
extern double g_x22;
extern double g_x23;
extern double g_x33;
extern double g_s1;
extern double g_s2;
extern double g_s3;
extern double g_r;
extern double g_s11;
extern double g_s12;
extern double g_s13;
extern double g_s22;
extern double g_s23;
extern double g_s33;
extern double values[N_VALUES];

	init_mat();
	g_r = 1.0;

#if 0
g_s11 = 0.3119;  g_s12 = 0.0292;  g_s13 = 0.0707; g_s22 = 0.3605;  g_s23 = 0.0462; g_s33 = 0.3276;
g_s1 = -0.0063; g_s2 = -0.0054; g_s3 = -0.0762;

/*
g_x11 = -0.161;  g_x12 = 0.4377;  g_x13 = 1.0604; g_x22 = 0.2038;  g_x23 = 0.6924; g_x33 = -0.0428;
g_y1 = -0.019; g_y2 = -0.0162; g_y3 = -0.2286; g_r = 1.0;
*/

/* points from the function optim_astro_f in call_asir.r */
g_x11 = -0.435171386; g_x12 =  0.129449919; g_x13 =  0.166561422; g_x22 =  0.222741744; g_x23 =  0.288446231; g_x33 =  -0.394944915;
g_y1 = -0.040351748; g_y2 = -0.003333136; g_y3 = -0.454246373;
g_r = 1.0;

 int i; 
 for (i=1; i<argc; i++) {
   if (strcmp(argv[i],"-v")==0) {
         Verbose = 1;
   }else if (strcmp(argv[i],"--verbose")==0) {
         Verbose = 1;
   }else if (strcmp(argv[i],"--idata")==0) {
     ++i;
         if (argv[i] == NULL) {
           fprintf(stderr,"input data file is not given.\n"); return(-1);
         }
         setData(argv[i]); /* set g_x*, g_y*, g_s*, g_r from the file. */
   }else {
         fprintf(stderr,"Unknown option.\n"); return(-1);
   }
 }
#endif

/* read data from files */
FILE *fp_pos, *fp_s;
char str_pos[1000];
char str_s[1000];
double *pos, *s;
pos = (double *)malloc(sizeof(double) * 9);
s = (double *)malloc(sizeof(double) * 9);

if (argc != 3) {
        printf("usage : %s pos_file s_file\n", argv[0]);
        exit(1);
}
fp_pos = fopen(argv[1], "r");
fp_s = fopen(argv[2], "r");
fgets(str_pos, 1000, fp_pos);
fgets(str_s, 1000, fp_s);
sscanf(str_pos, "%lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf", pos+0, pos+1, pos+2, pos+3, pos+4, pos+5, pos+6, pos+7, pos+8);
sscanf(str_s, "%lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf, %lf", s+0, s+1, s+2, s+3, s+4, s+5, s+6, s+7, s+8);

int i;
for (i = 0; i < 9; i++)
        printf("pos[%d] = %f\n", i, pos[i]);
for (i = 0; i < 9; i++)
        printf("s[%d] = %f\n", i, s[i]);

g_x11 = pos[0]; g_x12 = pos[1]; g_x13 = pos[2]; 
g_x22 = pos[3]; g_x23 = pos[4]; 
g_x33 = pos[5]; 
g_y1 = pos[6]; g_y2 = pos[7]; g_y3 = pos[8]; 

g_s11 = s[0]; g_s12 = s[1]; g_s13 = s[2];
g_s22 = s[3]; g_s23 = s[4]; 
g_s33 = s[5]; 
g_s1 = s[6]; g_s2 = s[7]; g_s3 = s[8]; 

	double *val;
	clock_t st, end;

	st = clock();
	val = init_val(2, g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3, g_s11, g_s12, g_s13, g_s22, g_s23, g_s33, g_s1, g_s2, g_s3);
	end = clock();
	show_v(val, N_VALUES);
	printf("time(init_val) : %f\n", (double)(end - st)/CLOCKS_PER_SEC);

	st = clock();
	search_min(val);
	end = clock();
	printf("time(search_min) : %f\n", (double)(end - st)/CLOCKS_PER_SEC);
	printf("search_min :\n");
	show_v(values, N_VALUES);
	val = init_val(2, g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3, g_s11, g_s12, g_s13, g_s22, g_s23, g_s33, g_s1, g_s2, g_s3);
	printf("init_val :\n");
	show_v(val, N_VALUES);
}



void init_mat()
{
extern gsl_matrix *a1, *b1, *c1, *e1;
extern gsl_matrix *a2, *b2, *c2, *e2;
extern gsl_matrix *a3, *b3, *c3, *e3;
extern gsl_matrix *p2, *q2, *p3, *q3, *r3;
extern gsl_matrix *db11;
extern gsl_matrix *dc11;
extern gsl_matrix *db12;
extern gsl_matrix *dc12;
extern gsl_matrix *db13;
extern gsl_matrix *dc13;
extern gsl_matrix *db21;
extern gsl_matrix *dc21;
extern gsl_matrix *db22;
extern gsl_matrix *dc22;
extern gsl_matrix *db23;
extern gsl_matrix *dc23;
extern gsl_matrix *db31;
extern gsl_matrix *dc31;
extern gsl_matrix *db32;
extern gsl_matrix *dc32;
extern gsl_matrix *db33;
extern gsl_matrix *dc33;
extern gsl_matrix *dq21;
extern gsl_matrix *dq31;
extern gsl_matrix *dr31;
extern gsl_matrix *dq22;
extern gsl_matrix *dq32;
extern gsl_matrix *dr32;
extern gsl_matrix *dq23;
extern gsl_matrix *dq33;
extern gsl_matrix *dr33;
extern gsl_matrix *inv_a1;
extern gsl_matrix *inv_a2;
extern gsl_matrix *inv_a3;
extern gsl_matrix *inv_p2;
extern gsl_matrix *inv_p3;
extern gsl_matrix *pf1_m;
extern gsl_matrix *pf2_m;
extern gsl_matrix *pf3_m;
extern gsl_matrix *pf1_nd_m;
extern gsl_matrix *pf2_nd_m;
extern gsl_matrix *pf3_nd_m;
extern gsl_matrix *pf11_m;
extern gsl_matrix *pf12_m;
extern gsl_matrix *pf13_m;
extern gsl_matrix *pf22_m;
extern gsl_matrix *pf23_m;
extern gsl_matrix *pf33_m;
extern gsl_matrix *pft_m;
extern gsl_vector *grad_v;

a1 = gsl_matrix_alloc(6, 6);
b1 = gsl_matrix_alloc(6, 6);
c1 = gsl_matrix_alloc(6, 3);
e1 = gsl_matrix_alloc(6, 7);
a2 = gsl_matrix_alloc(6, 6);
b2 = gsl_matrix_alloc(6, 6);
c2 = gsl_matrix_alloc(6, 3);
e2 = gsl_matrix_alloc(6, 7);
a3 = gsl_matrix_alloc(6, 6);
b3 = gsl_matrix_alloc(6, 6);
c3 = gsl_matrix_alloc(6, 3);
e3 = gsl_matrix_alloc(6, 7);
p2 = gsl_matrix_alloc(3, 3);
q2 = gsl_matrix_alloc(3, 6);
p3 = gsl_matrix_alloc(7, 7);
q3 = gsl_matrix_alloc(7, 3);
r3 = gsl_matrix_alloc(7, 6);
db11 = gsl_matrix_alloc(6, 6);
dc11 = gsl_matrix_alloc(6, 3);
db12 = gsl_matrix_alloc(6, 6);
dc12 = gsl_matrix_alloc(6, 3);
db13 = gsl_matrix_alloc(6, 6);
dc13 = gsl_matrix_alloc(6, 3);
db21 = gsl_matrix_alloc(6, 6);
dc21 = gsl_matrix_alloc(6, 3);
db22 = gsl_matrix_alloc(6, 6);
dc22 = gsl_matrix_alloc(6, 3);
db23 = gsl_matrix_alloc(6, 6);
dc23 = gsl_matrix_alloc(6, 3);
db31 = gsl_matrix_alloc(6, 6);
dc31 = gsl_matrix_alloc(6, 3);
db32 = gsl_matrix_alloc(6, 6);
dc32 = gsl_matrix_alloc(6, 3);
db33 = gsl_matrix_alloc(6, 6);
dc33 = gsl_matrix_alloc(6, 3);
dq21 = gsl_matrix_alloc(3, 6);
dq31 = gsl_matrix_alloc(7, 3);
dr31 = gsl_matrix_alloc(7, 6);
dq22 = gsl_matrix_alloc(3, 6);
dq32 = gsl_matrix_alloc(7, 3);
dr32 = gsl_matrix_alloc(7, 6);
dq23 = gsl_matrix_alloc(3, 6);
dq33 = gsl_matrix_alloc(7, 3);
dr33 = gsl_matrix_alloc(7, 6);
inv_a1 = gsl_matrix_alloc(6, 6);
inv_a2 = gsl_matrix_alloc(6, 6);
inv_a3 = gsl_matrix_alloc(6, 6);
inv_p2 = gsl_matrix_alloc(3, 3);
inv_p3 = gsl_matrix_alloc(7, 7);
pf1_m = gsl_matrix_alloc(6, 6);
pf2_m = gsl_matrix_alloc(6, 6);
pf3_m = gsl_matrix_alloc(6, 6);
pf1_nd_m = gsl_matrix_alloc(6, 6);
pf2_nd_m = gsl_matrix_alloc(6, 6);
pf3_nd_m = gsl_matrix_alloc(6, 6);
pf11_m = gsl_matrix_alloc(6, 6);
pf12_m = gsl_matrix_alloc(6, 6);
pf13_m = gsl_matrix_alloc(6, 6);
pf22_m = gsl_matrix_alloc(6, 6);
pf23_m = gsl_matrix_alloc(6, 6);
pf33_m = gsl_matrix_alloc(6, 6);
pft_m = gsl_matrix_alloc(N_VALUES, N_VALUES);
grad_v = gsl_vector_alloc(DIM);
}

void set_abce_1(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r)
{
extern gsl_matrix *a1, *b1, *c1, *e1;
gsl_matrix_set(a1, 0, 0, 1);
gsl_matrix_set(a1, 1, 1, 1);
gsl_matrix_set(a1, 2, 1, 1*x12);
gsl_matrix_set(a1, 2, 2, (-2)*x11 + 2*x22);
gsl_matrix_set(a1, 2, 3, 1*x23);
gsl_matrix_set(a1, 3, 1, 1*x13);
gsl_matrix_set(a1, 3, 2, 1*x23);
gsl_matrix_set(a1, 3, 3, (-2)*x11 + 2*x33);
gsl_matrix_set(a1, 4, 4, 1);
gsl_matrix_set(a1, 5, 5, 2*x11 + (-2)*x22);
gsl_matrix_set(b1, 0, 1, 1);
gsl_matrix_set(b1, 1, 4, 1);
gsl_matrix_set(b1, 2, 1, (-1)*y2);
gsl_matrix_set(b1, 2, 2, 1*y1);
gsl_matrix_set(b1, 2, 5, 1*x12);
gsl_matrix_set(b1, 3, 0, 1*x13*r*r);
gsl_matrix_set(b1, 3, 1, (-1)*y3);
gsl_matrix_set(b1, 3, 3, 1*y1);
gsl_matrix_set(b1, 3, 4, (-1)*x13);
gsl_matrix_set(b1, 3, 5, (-1)*x13);
gsl_matrix_set(b1, 5, 1, 1);
gsl_matrix_set(b1, 5, 5, (-1)*y1);
gsl_matrix_set(c1, 2, 2, 1*x13);
gsl_matrix_set(c1, 3, 2, 1*x12);
gsl_matrix_set(c1, 5, 0, 1*y2);
gsl_matrix_set(e1, 4, 0, 1);
gsl_matrix_set(e1, 5, 1, 1*x12);
gsl_matrix_set(e1, 5, 4, 1*x23);
gsl_matrix_set(e1, 5, 5, (-1)*x12);
gsl_matrix_set(e1, 5, 6, (-1)*x13);
}

void set_abce_2(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r)
{
extern gsl_matrix *a2, *b2, *c2, *e2;
gsl_matrix_set(a2, 0, 0, 1);
gsl_matrix_set(a2, 1, 1, 2*x11 + (-2)*x22);
gsl_matrix_set(a2, 1, 2, 1*x12);
gsl_matrix_set(a2, 1, 3, 1*x13);
gsl_matrix_set(a2, 2, 2, 1);
gsl_matrix_set(a2, 3, 1, 1*x13);
gsl_matrix_set(a2, 3, 2, 1*x23);
gsl_matrix_set(a2, 3, 3, (-2)*x22 + 2*x33);
gsl_matrix_set(a2, 4, 4, (-2)*x11 + 2*x22);
gsl_matrix_set(a2, 5, 5, 1);
gsl_matrix_set(b2, 0, 2, 1);
gsl_matrix_set(b2, 1, 1, 1*y2);
gsl_matrix_set(b2, 1, 2, (-1)*y1);
gsl_matrix_set(b2, 1, 4, 1*x12);
gsl_matrix_set(b2, 2, 5, 1);
gsl_matrix_set(b2, 3, 0, 1*r*r*x23);
gsl_matrix_set(b2, 3, 2, (-1)*y3);
gsl_matrix_set(b2, 3, 3, 1*y2);
gsl_matrix_set(b2, 3, 4, (-1)*x23);
gsl_matrix_set(b2, 3, 5, (-1)*x23);
gsl_matrix_set(b2, 4, 2, 1);
gsl_matrix_set(b2, 4, 4, (-1)*y2);
gsl_matrix_set(c2, 1, 1, 1*x23);
gsl_matrix_set(c2, 3, 1, 1*x12);
gsl_matrix_set(c2, 4, 0, 1*y1);
gsl_matrix_set(e2, 4, 0, (-1)*x12);
gsl_matrix_set(e2, 4, 2, (-1)*x23);
gsl_matrix_set(e2, 4, 3, 1*x12);
gsl_matrix_set(e2, 4, 4, 1*x13);
gsl_matrix_set(e2, 5, 5, 1);
}

void set_abce_3(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r)
{
extern gsl_matrix *a3, *b3, *c3, *e3;
gsl_matrix_set(a3, 0, 0, 1);
gsl_matrix_set(a3, 1, 1, 2*x11 + (-2)*x33);
gsl_matrix_set(a3, 1, 2, 1*x12);
gsl_matrix_set(a3, 1, 3, 1*x13);
gsl_matrix_set(a3, 2, 1, 1*x12);
gsl_matrix_set(a3, 2, 2, 2*x22 + (-2)*x33);
gsl_matrix_set(a3, 2, 3, 1*x23);
gsl_matrix_set(a3, 3, 3, 1);
gsl_matrix_set(a3, 4, 4, (-2)*x11 + 2*x33);
gsl_matrix_set(a3, 5, 5, (-2)*x22 + 2*x33);
gsl_matrix_set(b3, 0, 3, 1);
gsl_matrix_set(b3, 1, 1, 1*y3);
gsl_matrix_set(b3, 1, 3, (-1)*y1);
gsl_matrix_set(b3, 1, 4, 1*x13);
gsl_matrix_set(b3, 2, 2, 1*y3);
gsl_matrix_set(b3, 2, 3, (-1)*y2);
gsl_matrix_set(b3, 2, 5, 1*x23);
gsl_matrix_set(b3, 3, 0, 1*r*r);
gsl_matrix_set(b3, 3, 4, (-1));
gsl_matrix_set(b3, 3, 5, (-1));
gsl_matrix_set(b3, 4, 1, 1*x13*r*r);
gsl_matrix_set(b3, 4, 3, 1);
gsl_matrix_set(b3, 4, 4, (-1)*y3);
gsl_matrix_set(b3, 5, 2, 1*r*r*x23);
gsl_matrix_set(b3, 5, 3, 1);
gsl_matrix_set(b3, 5, 5, (-1)*y3);
gsl_matrix_set(c3, 1, 0, 1*x23);
gsl_matrix_set(c3, 2, 0, 1*x13);
gsl_matrix_set(c3, 4, 1, 1*y1);
gsl_matrix_set(c3, 5, 2, 1*y2);
gsl_matrix_set(e3, 4, 0, (-2)*x13);
gsl_matrix_set(e3, 4, 1, (-1)*x23);
gsl_matrix_set(e3, 4, 3, (-1)*x13);
gsl_matrix_set(e3, 4, 4, 1*x12);
gsl_matrix_set(e3, 5, 1, (-1)*x23);
gsl_matrix_set(e3, 5, 3, (-1)*x13);
gsl_matrix_set(e3, 5, 4, 1*x12);
gsl_matrix_set(e3, 5, 5, (-2)*x23);
}

void set_pqr(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r)
{
extern gsl_matrix *p2, *q2, *p3, *q3, *r3;
gsl_matrix_set(p2, 0, 0, (-2)*x11 + 2*x22);
gsl_matrix_set(p2, 0, 1, 1*x23);
gsl_matrix_set(p2, 0, 2, (-1)*x13);
gsl_matrix_set(p2, 1, 0, 1*x23);
gsl_matrix_set(p2, 1, 1, (-2)*x11 + 2*x33);
gsl_matrix_set(p2, 1, 2, (-1)*x12);
gsl_matrix_set(p2, 2, 0, 1*x13);
gsl_matrix_set(p2, 2, 1, (-1)*x12);
gsl_matrix_set(p2, 2, 2, (-2)*x22 + 2*x33);
gsl_matrix_set(q2, 0, 1, 1*y2);
gsl_matrix_set(q2, 0, 2, (-1)*y1);
gsl_matrix_set(q2, 0, 4, 1*x12);
gsl_matrix_set(q2, 0, 5, (-1)*x12);
gsl_matrix_set(q2, 1, 0, (-1)*x13*r*r);
gsl_matrix_set(q2, 1, 1, 1*y3);
gsl_matrix_set(q2, 1, 3, (-1)*y1);
gsl_matrix_set(q2, 1, 4, 2*x13);
gsl_matrix_set(q2, 1, 5, 1*x13);
gsl_matrix_set(q2, 2, 0, (-1)*r*r*x23);
gsl_matrix_set(q2, 2, 2, 1*y3);
gsl_matrix_set(q2, 2, 3, (-1)*y2);
gsl_matrix_set(q2, 2, 4, 1*x23);
gsl_matrix_set(q2, 2, 5, 2*x23);
gsl_matrix_set(p3, 0, 0, 2*x11 + (-2)*x33);
gsl_matrix_set(p3, 0, 1, 1*x12);
gsl_matrix_set(p3, 0, 2, 2*x13);
gsl_matrix_set(p3, 0, 3, 2*x11 + (-2)*x33);
gsl_matrix_set(p3, 0, 4, 1*x23);
gsl_matrix_set(p3, 0, 5, 1*x12);
gsl_matrix_set(p3, 0, 6, 1*x13);
gsl_matrix_set(p3, 1, 0, 1*x12);
gsl_matrix_set(p3, 1, 1, (-2)*x11 + 2*x22);
gsl_matrix_set(p3, 1, 2, 1*x23);
gsl_matrix_set(p3, 1, 3, (-1)*x12);
gsl_matrix_set(p3, 1, 4, (-1)*x13);
gsl_matrix_set(p3, 2, 0, 2*x13);
gsl_matrix_set(p3, 2, 1, 1*x23);
gsl_matrix_set(p3, 2, 2, (-2)*x11 + 2*x33);
gsl_matrix_set(p3, 2, 3, 1*x13);
gsl_matrix_set(p3, 2, 4, (-1)*x12);
gsl_matrix_set(p3, 3, 1, 1*x12);
gsl_matrix_set(p3, 3, 3, (-2)*x11 + 2*x22);
gsl_matrix_set(p3, 3, 4, 1*x23);
gsl_matrix_set(p3, 3, 5, (-1)*x12);
gsl_matrix_set(p3, 3, 6, (-1)*x13);
gsl_matrix_set(p3, 4, 0, 1*x23);
gsl_matrix_set(p3, 4, 1, 1*x13);
gsl_matrix_set(p3, 4, 2, (-1)*x12);
gsl_matrix_set(p3, 4, 3, 2*x23);
gsl_matrix_set(p3, 4, 4, (-2)*x22 + 2*x33);
gsl_matrix_set(p3, 5, 0, 1*x12);
gsl_matrix_set(p3, 5, 1, 2*x22 + (-2)*x33);
gsl_matrix_set(p3, 5, 2, 1*x23);
gsl_matrix_set(p3, 5, 3, 1*x12);
gsl_matrix_set(p3, 5, 4, 1*x13);
gsl_matrix_set(p3, 5, 5, 2*x22 + (-2)*x33);
gsl_matrix_set(p3, 5, 6, 2*x23);
gsl_matrix_set(p3, 6, 1, 1*x23);
gsl_matrix_set(p3, 6, 3, 1*x13);
gsl_matrix_set(p3, 6, 4, (-1)*x12);
gsl_matrix_set(p3, 6, 5, 2*x23);
gsl_matrix_set(p3, 6, 6, (-2)*x22 + 2*x33);
gsl_matrix_set(q3, 0, 1, 1*y3);
gsl_matrix_set(q3, 1, 0, (-1)*y1);
gsl_matrix_set(q3, 2, 1, (-1)*y1);
gsl_matrix_set(q3, 3, 0, 1*y2);
gsl_matrix_set(q3, 4, 0, 1*y3);
gsl_matrix_set(q3, 4, 1, (-1)*y2);
gsl_matrix_set(q3, 5, 2, 1*y3);
gsl_matrix_set(q3, 6, 2, (-1)*y2);
gsl_matrix_set(r3, 0, 0, (-1)*y1*r*r);
gsl_matrix_set(r3, 0, 1, (-2)*x11*r*r + 2*r*r*x33 + 1);
gsl_matrix_set(r3, 0, 2, (-1)*x12*r*r);
gsl_matrix_set(r3, 0, 3, (-1)*x13*r*r);
gsl_matrix_set(r3, 0, 4, 1*y1);
gsl_matrix_set(r3, 0, 5, 1*y1);
gsl_matrix_set(r3, 1, 2, (-1));
gsl_matrix_set(r3, 1, 4, 1*y2);
gsl_matrix_set(r3, 2, 1, (-1)*x13*r*r);
gsl_matrix_set(r3, 2, 3, (-1));
gsl_matrix_set(r3, 2, 4, 1*y3);
gsl_matrix_set(r3, 3, 1, 1);
gsl_matrix_set(r3, 3, 5, (-1)*y1);
gsl_matrix_set(r3, 4, 1, (-1)*r*r*x23);
gsl_matrix_set(r3, 5, 0, (-1)*y2*r*r);
gsl_matrix_set(r3, 5, 1, (-1)*x12*r*r);
gsl_matrix_set(r3, 5, 2, (-2)*r*r*x22 + 2*r*r*x33 + 1);
gsl_matrix_set(r3, 5, 3, (-1)*r*r*x23);
gsl_matrix_set(r3, 5, 4, 1*y2);
gsl_matrix_set(r3, 5, 5, 1*y2);
gsl_matrix_set(r3, 6, 2, (-1)*r*r*x23);
gsl_matrix_set(r3, 6, 3, (-1));
gsl_matrix_set(r3, 6, 5, 1*y3);
}

void set_dbcqr(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r)
{
extern gsl_matrix *db11;
extern gsl_matrix *dc11;
extern gsl_matrix *db12;
extern gsl_matrix *dc12;
extern gsl_matrix *db13;
extern gsl_matrix *dc13;
extern gsl_matrix *db21;
extern gsl_matrix *dc21;
extern gsl_matrix *db22;
extern gsl_matrix *dc22;
extern gsl_matrix *db23;
extern gsl_matrix *dc23;
extern gsl_matrix *db31;
extern gsl_matrix *dc31;
extern gsl_matrix *db32;
extern gsl_matrix *dc32;
extern gsl_matrix *db33;
extern gsl_matrix *dc33;
extern gsl_matrix *dq21;
extern gsl_matrix *dq31;
extern gsl_matrix *dr31;
extern gsl_matrix *dq22;
extern gsl_matrix *dq32;
extern gsl_matrix *dr32;
extern gsl_matrix *dq23;
extern gsl_matrix *dq33;
extern gsl_matrix *dr33;
gsl_matrix_set(db11, 2, 2, 1);
gsl_matrix_set(db11, 3, 3, 1);
gsl_matrix_set(db11, 5, 5, (-1));
gsl_matrix_set(db12, 2, 1, (-1));
gsl_matrix_set(dc12, 5, 0, 1);
gsl_matrix_set(db13, 3, 1, (-1));
gsl_matrix_set(db21, 1, 2, (-1));
gsl_matrix_set(dc21, 4, 0, 1);
gsl_matrix_set(db22, 1, 1, 1);
gsl_matrix_set(db22, 3, 3, 1);
gsl_matrix_set(db22, 4, 4, (-1));
gsl_matrix_set(db23, 3, 2, (-1));
gsl_matrix_set(db31, 1, 3, (-1));
gsl_matrix_set(dc31, 4, 1, 1);
gsl_matrix_set(db32, 2, 3, (-1));
gsl_matrix_set(dc32, 5, 2, 1);
gsl_matrix_set(db33, 1, 1, 1);
gsl_matrix_set(db33, 2, 2, 1);
gsl_matrix_set(db33, 4, 4, (-1));
gsl_matrix_set(db33, 5, 5, (-1));
gsl_matrix_set(dq21, 0, 2, (-1));
gsl_matrix_set(dq21, 1, 3, (-1));
gsl_matrix_set(dq31, 1, 0, (-1));
gsl_matrix_set(dq31, 2, 1, (-1));
gsl_matrix_set(dr31, 0, 0, (-1)*r*r);
gsl_matrix_set(dr31, 0, 4, 1);
gsl_matrix_set(dr31, 0, 5, 1);
gsl_matrix_set(dr31, 3, 5, (-1));
gsl_matrix_set(dq22, 0, 1, 1);
gsl_matrix_set(dq22, 2, 3, (-1));
gsl_matrix_set(dq32, 3, 0, 1);
gsl_matrix_set(dq32, 4, 1, (-1));
gsl_matrix_set(dq32, 6, 2, (-1));
gsl_matrix_set(dr32, 1, 4, 1);
gsl_matrix_set(dr32, 5, 0, (-1)*r*r);
gsl_matrix_set(dr32, 5, 4, 1);
gsl_matrix_set(dr32, 5, 5, 1);
gsl_matrix_set(dq23, 1, 1, 1);
gsl_matrix_set(dq23, 2, 2, 1);
gsl_matrix_set(dq33, 0, 1, 1);
gsl_matrix_set(dq33, 4, 0, 1);
gsl_matrix_set(dq33, 5, 2, 1);
gsl_matrix_set(dr33, 2, 4, 1);
gsl_matrix_set(dr33, 6, 5, 1);
}

void pf_all(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r)
{
extern gsl_matrix *a1, *inv_a1, *b1, *c1, *e1;
extern gsl_matrix *a2, *inv_a2, *b2, *c2, *e2;
extern gsl_matrix *a3, *inv_a3, *b3, *c3, *e3;
extern gsl_matrix *p2, *inv_p2, *q2;
extern gsl_matrix *p3, *inv_p3, *q3, *r3;
extern gsl_matrix *pf1_m;
extern gsl_matrix *pf1_nd_m;
extern gsl_matrix *pf2_m;
extern gsl_matrix *pf2_nd_m;
extern gsl_matrix *pf3_m;
extern gsl_matrix *pf3_nd_m;
extern double g_s1;
extern double g_s2;
extern double g_s3;

extern gsl_matrix *db11;
extern gsl_matrix *dc11;
extern gsl_matrix *db12;
extern gsl_matrix *dc12;
extern gsl_matrix *db13;
extern gsl_matrix *dc13;
extern gsl_matrix *db21;
extern gsl_matrix *dc21;
extern gsl_matrix *db22;
extern gsl_matrix *dc22;
extern gsl_matrix *db23;
extern gsl_matrix *dc23;
extern gsl_matrix *db31;
extern gsl_matrix *dc31;
extern gsl_matrix *db32;
extern gsl_matrix *dc32;
extern gsl_matrix *db33;
extern gsl_matrix *dc33;
extern gsl_matrix *dq21;
extern gsl_matrix *dq31;
extern gsl_matrix *dr31;
extern gsl_matrix *dq22;
extern gsl_matrix *dq32;
extern gsl_matrix *dr32;
extern gsl_matrix *dq23;
extern gsl_matrix *dq33;
extern gsl_matrix *dr33;

extern gsl_matrix *pf11_m;
extern gsl_matrix *pf12_m;
extern gsl_matrix *pf13_m;
extern gsl_matrix *pf22_m;
extern gsl_matrix *pf23_m;
extern gsl_matrix *pf33_m;
extern double g_s11;
extern double g_s12;
extern double g_s13;
extern double g_s22;
extern double g_s23;
extern double g_s33;
gsl_matrix *t1;
gsl_matrix *t2;
gsl_matrix *t3;
gsl_matrix *t4;
gsl_matrix *t5;
gsl_matrix *t6;

static double o_y1;
static double o_y2;
static double o_y3;
static double o_x11;
static double o_x12;
static double o_x13;
static double o_x22;
static double o_x23;
static double o_x33;
if (o_y1 == y1 && o_y2 == y2 && o_y3 == y3 && o_x11 == x11 &&o_x12 == x12 &&o_x13 == x13 &&o_x22 == x22 &&o_x23 == x23 &&o_x33 == x33) 
	return;
o_y1 = y1;
o_y2 = y2;
o_y3 = y3;
o_x11 = x11;
o_x12 = x12;
o_x13 = x13;
o_x22 = x22;
o_x23 = x23;
o_x33 = x33;

set_pqr(x11, x12, x13, x22, x23, x33, y1, y2, y3, r);
invmat(p2, inv_p2);
invmat(p3, inv_p3);

set_abce_1(x11, x12, x13, x22, x23, x33, y1, y2, y3, r);
invmat(a1, inv_a1);
t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(c1->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t1, 0.0, t2);
t3 = gsl_matrix_alloc(q3->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t1, 0.0, t3);
gsl_matrix_sub(t3, r3);
t4 = gsl_matrix_alloc(inv_p3->size1, t3->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e1->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
gsl_matrix_add(t5, b1);
gsl_matrix_sub(t5, t2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t2);
gsl_matrix_memcpy(pf1_nd_m, t2);
gsl_matrix_memcpy(pf1_m, t2);

gsl_matrix_set_identity(t2);
gsl_matrix_scale(t2, -g_s1);
gsl_matrix_add(pf1_m, t2);

gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);

set_abce_2(x11, x12, x13, x22, x23, x33, y1, y2, y3, r);
invmat(a2, inv_a2);
t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(c2->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c2, t1, 0.0, t2);
t3 = gsl_matrix_alloc(q3->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t1, 0.0, t3);
gsl_matrix_sub(t3, r3);
t4 = gsl_matrix_alloc(inv_p3->size1, t3->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e2->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e2, t4, 0.0, t5);
gsl_matrix_add(t5, b2);
gsl_matrix_sub(t5, t2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a2, t5, 0.0, t2);
gsl_matrix_memcpy(pf2_nd_m, t2);
gsl_matrix_memcpy(pf2_m, t2);

gsl_matrix_set_identity(t2);
gsl_matrix_scale(t2, -g_s2);
gsl_matrix_add(pf2_m, t2);

gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);

set_abce_3(x11, x12, x13, x22, x23, x33, y1, y2, y3, r);
invmat(a3, inv_a3);
t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(c3->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c3, t1, 0.0, t2);
t3 = gsl_matrix_alloc(q3->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t1, 0.0, t3);
gsl_matrix_sub(t3, r3);
t4 = gsl_matrix_alloc(inv_p3->size1, t3->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e3->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e3, t4, 0.0, t5);
gsl_matrix_add(t5, b3);
gsl_matrix_sub(t5, t2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a3, t5, 0.0, t2);
gsl_matrix_memcpy(pf3_nd_m, t2);
gsl_matrix_memcpy(pf3_m, t2);

gsl_matrix_set_identity(t2);
gsl_matrix_scale(t2, -g_s3);
gsl_matrix_add(pf3_m, t2);

gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);

set_dbcqr(x11, x12, x13, x22, x23, x33, y1, y2, y3, r);
t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(inv_p2->size1, dq21->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq21, 0.0, t2);
t3 = gsl_matrix_alloc(dq31->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq31, t1, 0.0, t3);
t4 = gsl_matrix_alloc(q3->size1, t2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr31);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e1->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
gsl_matrix_add(t5, db11); 
t6 = gsl_matrix_alloc(dc11->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc11, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf1_nd_m, pf1_nd_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf11_m, t5);

gsl_matrix_set_identity(t5);
gsl_matrix_scale(t5, -g_s11);
gsl_matrix_add(pf11_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);

t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(inv_p2->size1, dq22->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq22, 0.0, t2);
t3 = gsl_matrix_alloc(dq32->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq32, t1, 0.0, t3);
t4 = gsl_matrix_alloc(q3->size1, t2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr32);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e1->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
gsl_matrix_add(t5, db12); 
t6 = gsl_matrix_alloc(dc12->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc12, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf1_nd_m, pf2_nd_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf12_m, t5);

gsl_matrix_set_identity(t5);
gsl_matrix_scale(t5, -g_s12);
gsl_matrix_add(pf12_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);

t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(inv_p2->size1, dq23->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq23, 0.0, t2);
t3 = gsl_matrix_alloc(dq33->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq33, t1, 0.0, t3);
t4 = gsl_matrix_alloc(q3->size1, t2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr33);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e1->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e1, t4, 0.0, t5);
gsl_matrix_add(t5, db13); 
t6 = gsl_matrix_alloc(dc13->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc13, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c1, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a1, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf1_nd_m, pf3_nd_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf13_m, t5);

gsl_matrix_set_identity(t5);
gsl_matrix_scale(t5, -g_s13);
gsl_matrix_add(pf13_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);

t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(inv_p2->size1, dq22->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq22, 0.0, t2);
t3 = gsl_matrix_alloc(dq32->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq32, t1, 0.0, t3);
t4 = gsl_matrix_alloc(q3->size1, t2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr32);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e2->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e2, t4, 0.0, t5);
gsl_matrix_add(t5, db22); 
t6 = gsl_matrix_alloc(dc22->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc22, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c2, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a2, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf2_nd_m, pf2_nd_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf22_m, t5);

gsl_matrix_set_identity(t5);
gsl_matrix_scale(t5, -g_s22);
gsl_matrix_add(pf22_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);

t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(inv_p2->size1, dq23->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq23, 0.0, t2);
t3 = gsl_matrix_alloc(dq33->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq33, t1, 0.0, t3);
t4 = gsl_matrix_alloc(q3->size1, t2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr33);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e2->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e2, t4, 0.0, t5);
gsl_matrix_add(t5, db23); 
t6 = gsl_matrix_alloc(dc23->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc23, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c2, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a2, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf2_nd_m, pf3_nd_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf23_m, t5);

gsl_matrix_set_identity(t5);
gsl_matrix_scale(t5, -g_s23);
gsl_matrix_add(pf23_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);

t1 = gsl_matrix_alloc(inv_p2->size1, q2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, q2, 0.0, t1);
t2 = gsl_matrix_alloc(inv_p2->size1, dq23->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p2, dq23, 0.0, t2);
t3 = gsl_matrix_alloc(dq33->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dq33, t1, 0.0, t3);
t4 = gsl_matrix_alloc(q3->size1, t2->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, q3, t2, 0.0, t4);
gsl_matrix_add(t3, t4);
gsl_matrix_sub(t3, dr33);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_p3, t3, 0.0, t4);
t5 = gsl_matrix_alloc(e3->size1, t4->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, e3, t4, 0.0, t5);
gsl_matrix_add(t5, db33); 
t6 = gsl_matrix_alloc(dc33->size1, t1->size2);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, dc33, t1, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, c3, t2, 0.0, t6);
gsl_matrix_sub(t5, t6); 
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, inv_a3, t5, 0.0, t6);
gsl_blas_dgemm(CblasNoTrans, CblasNoTrans, 1.0, pf3_nd_m, pf3_nd_m, 0.0, t5);
gsl_matrix_add(t5, t6); 
gsl_matrix_memcpy(pf33_m, t5);

gsl_matrix_set_identity(t5);
gsl_matrix_scale(t5, -g_s33);
gsl_matrix_add(pf33_m, t5);
gsl_matrix_free(t1);
gsl_matrix_free(t2);
gsl_matrix_free(t3);
gsl_matrix_free(t4);
gsl_matrix_free(t5);
gsl_matrix_free(t6);

}

void invmat(gsl_matrix *m, gsl_matrix *invm)
{
	int n = m->size1;
	int s;
	gsl_permutation *p = gsl_permutation_alloc(n);
	gsl_matrix *old_m = gsl_matrix_alloc(m->size1, m->size2);
	gsl_matrix_memcpy(old_m, m);

	gsl_linalg_LU_decomp(m, p, &s);
	gsl_linalg_LU_invert(m, p, invm);

	gsl_permutation_free(p);
	gsl_matrix_memcpy(m, old_m);
	gsl_matrix_free(old_m);
}

int move_t(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double xx11, double xx12, double xx13, double xx22, double xx23, double xx33, double yy1, double yy2, double yy3, double *val)
{
extern double g_x11;
extern double g_x12;
extern double g_x13;
extern double g_x22;
extern double g_x23;
extern double g_x33;
extern double g_y1;
extern double g_y2;
extern double g_y3;
extern double move_t_points[DIM];

double params[DIM];
params[0] = xx11 - x11;
params[1] = xx12 - x12;
params[2] = xx13 - x13;
params[3] = xx22 - x22;
params[4] = xx23 - x23;
params[5] = xx33 - x33;
params[6] = yy1 - y1;
params[7] = yy2 - y2;
params[8] = yy3 - y3;

const gsl_odeiv_step_type *T = ODEIV_STEP_TYPE;
gsl_odeiv_step *s = gsl_odeiv_step_alloc(T, N_VALUES);
gsl_odeiv_control *c = gsl_odeiv_control_y_new(1e-6, 0.0);
gsl_odeiv_evolve *e = gsl_odeiv_evolve_alloc(N_VALUES);
gsl_odeiv_system sys = {sys_t, NULL, N_VALUES, params};

double t = 0.0;
double h = 1e-6;
double hmin = 1e-6;

#ifdef DEBUG_RK
printf("Runge-Kutta: [%f,%f,%f,%f,%f,%f,%f,%f,%f] -> [%f,%f,%f,%f,%f,%f,%f,%f,%f]\n",x11, x12, x13, x22, x23, x33, y1, y2, y3, xx11, xx12, xx13, xx22, xx23, xx33, yy1, yy2, yy3);
#endif
while (t < 1.0) {
	int status = gsl_odeiv_evolve_apply(e, c, s, &sys, &t, 1.0, &h, val);
	if (status != GSL_SUCCESS) break;
	if (h < hmin) {
		printf("move_t : h is too small\n");
		move_t_points[0] = g_x11 + t * params[0];
		move_t_points[1] = g_x12 + t * params[1];
		move_t_points[2] = g_x13 + t * params[2];
		move_t_points[3] = g_x22 + t * params[3];
		move_t_points[4] = g_x23 + t * params[4];
		move_t_points[5] = g_x33 + t * params[5];
		move_t_points[6] = g_y1 + t * params[6];
		move_t_points[7] = g_y2 + t * params[7];
		move_t_points[8] = g_y3 + t * params[8];
		gsl_odeiv_evolve_free(e);
		gsl_odeiv_control_free(c);
		gsl_odeiv_step_free(s);
		return MOVE_T_FAIL;
	}
#ifdef DEBUG_RK
	printf("t = %f [%f,%f,%f,%f,%f,%f] : ", t, val[0],val[1],val[2],val[3],val[4],val[5]);
	printf("[%f,%f,%f,%f,%f,%f,%f,%f,%f]\n", g_x11 + t * params[0], g_x12 + t * params[1], g_x13 + t * params[2], g_x22 + t * params[3], g_x23 + t * params[4], g_x33 + t * params[5], g_y1 + t * params[6], g_y2 + t * params[7], g_y3 + t * params[8]);
#endif
}
gsl_odeiv_evolve_free(e);
gsl_odeiv_control_free(c);
gsl_odeiv_step_free(s);
return MOVE_T_SUCCESS;
}

int sys_t(double t, const double *y, double *val, double *params)
{
extern double g_x11;
extern double g_x12;
extern double g_x13;
extern double g_x22;
extern double g_x23;
extern double g_x33;
extern double g_y1;
extern double g_y2;
extern double g_y3;
extern double g_r;
extern gsl_matrix *pf11_m;
extern gsl_matrix *pf12_m;
extern gsl_matrix *pf13_m;
extern gsl_matrix *pf22_m;
extern gsl_matrix *pf23_m;
extern gsl_matrix *pf33_m;
extern gsl_matrix *pf1_m;
extern gsl_matrix *pf2_m;
extern gsl_matrix *pf3_m;
extern gsl_matrix *pft_m;

int i, j;
double n_x11, n_x12, n_x13, n_x22, n_x23, n_x33, n_y1, n_y2, n_y3, n_r;

gsl_matrix *t_m = gsl_matrix_alloc(pf11_m->size1, pf11_m->size2);

n_x11 = g_x11 + t * params[0];
n_x12 = g_x12 + t * params[1];
n_x13 = g_x13 + t * params[2];
n_x22 = g_x22 + t * params[3];
n_x23 = g_x23 + t * params[4];
n_x33 = g_x33 + t * params[5];
n_y1 = g_y1 + t * params[6];
n_y2 = g_y2 + t * params[7];
n_y3 = g_y3 + t * params[8];
n_r = g_r;
gsl_matrix_set_zero(pft_m);
pf_all(n_x11, n_x12, n_x13, n_x22, n_x23, n_x33, n_y1, n_y2, n_y3, n_r);
gsl_matrix_memcpy(t_m, pf11_m);
gsl_matrix_scale(t_m, params[0]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf12_m);
gsl_matrix_scale(t_m, params[1]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf13_m);
gsl_matrix_scale(t_m, params[2]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf22_m);
gsl_matrix_scale(t_m, params[3]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf23_m);
gsl_matrix_scale(t_m, params[4]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf33_m);
gsl_matrix_scale(t_m, params[5]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf1_m);
gsl_matrix_scale(t_m, params[6]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf2_m);
gsl_matrix_scale(t_m, params[7]);
gsl_matrix_add(pft_m, t_m);
gsl_matrix_memcpy(t_m, pf3_m);
gsl_matrix_scale(t_m, params[8]);
gsl_matrix_add(pft_m, t_m);
for (i = 0; i < N_VALUES; i++) {
	val[i] = 0.0;
	for (j = 0; j < N_VALUES; j++)
		val[i] += gsl_matrix_get(pft_m, i, j) * y[j];
}
gsl_matrix_free(t_m);
return GSL_SUCCESS;
}

double *init_val(int dim, double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double s11, double s12, double s13, double s22, double s23, double s33, double s1, double s2, double s3)
{
double xxx[MAXSIZE][MAXSIZE];
xxx[0][0] = x11;
xxx[0][1] = x12/2;
xxx[0][2] = x13/2;
xxx[1][0] = x12/2;
xxx[1][1] = x22;
xxx[1][2] = x23/2;
xxx[2][0] = x13/2;
xxx[2][1] = x23/2;
xxx[2][2] = x33;
double y[] = {y1, y2, y3};
double exp_part = exp(-(s11 * x11 + s12 * x12 + s13 * x13 + s22 * x22 + s23 * x23 + s33 * x33 + s1 * y1 + s2 * y2 + s3 * y3));
int maxdeg = 10;
int weight[] = {1, 1, 1, 1, 1, 1};
double *val = fbnd(dim, xxx, y, maxdeg, weight);
int i;
for(i = 0; i < 2*dim+2; i++)
	val[i] = exp_part * val[i];
return val;
}

void search_min(double *val)
{
extern double g_x11;
extern double g_x12;
extern double g_x13;
extern double g_x22;
extern double g_x23;
extern double g_x33;
extern double g_y1;
extern double g_y2;
extern double g_y3;
extern double values[N_VALUES];
extern gsl_vector *grad_v;

size_t iter = 0;
int status;
const gsl_multimin_fdfminimizer_type *T;
gsl_multimin_fdfminimizer *s;
int move_t_status;
double t_x11;
double t_x12;
double t_x13;
double t_x22;
double t_x23;
double t_x33;
double t_y1;
double t_y2;
double t_y3;

int j;
for (j = 0; j < N_VALUES; j++)
	values[j] = val[j];
gsl_vector *x;
gsl_multimin_function_fdf my_func;
my_func.n = 9;
my_func.f = &my_f;
my_func.df = &my_df;
my_func.fdf = &my_fdf;
my_func.params = NULL;
x = gsl_vector_alloc(9);
gsl_vector_set(x, 0, g_x11);
gsl_vector_set(x, 1, g_x12);
gsl_vector_set(x, 2, g_x13);
gsl_vector_set(x, 3, g_x22);
gsl_vector_set(x, 4, g_x23);
gsl_vector_set(x, 5, g_x33);
gsl_vector_set(x, 6, g_y1);
gsl_vector_set(x, 7, g_y2);
gsl_vector_set(x, 8, g_y3);
T = MULTIMIN_FDFMINIMIZER_TYPE;
s = gsl_multimin_fdfminimizer_alloc(T, DIM);
gsl_multimin_fdfminimizer_set(s, &my_func, x, 0.01, 1e-4);
do {
	iter++;
	status = gsl_multimin_fdfminimizer_iterate(s);
	if (status) {
		if (status == GSL_ENOPROG)
			printf("GSL_ENOPROG : gsl_multimin_fdminimizer_iterate\n");
		break;
	}
	status = gsl_multimin_test_gradient(s->gradient, GRAD_NORM);
	if (status == GSL_SUCCESS) printf("Minimum found\n");
	t_x11 = gsl_vector_get(s->x, 0);
	t_x12 = gsl_vector_get(s->x, 1);
	t_x13 = gsl_vector_get(s->x, 2);
	t_x22 = gsl_vector_get(s->x, 3);
	t_x23 = gsl_vector_get(s->x, 4);
	t_x33 = gsl_vector_get(s->x, 5);
	t_y1 = gsl_vector_get(s->x, 6);
	t_y2 = gsl_vector_get(s->x, 7);
	t_y3 = gsl_vector_get(s->x, 8);
	printf("%d, %g, %g, %g, %g, %g, %g, %g, %g, %g, %g\n", iter, t_x11, t_x12, t_x13, t_x22, t_x23, t_x33, t_y1, t_y2, t_y3, s->f);
	move_t_status = move_t(g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3, t_x11, t_x12, t_x13, t_x22, t_x23, t_x33, t_y1, t_y2, t_y3, values);
	if (move_t_status == MOVE_T_SUCCESS) {
		g_x11 = t_x11;
		g_x12 = t_x12;
		g_x13 = t_x13;
		g_x22 = t_x22;
		g_x23 = t_x23;
		g_x33 = t_x33;
		g_y1 = t_y1;
		g_y2 = t_y2;
		g_y3 = t_y3;
	} else {
		printf("move_t failed\n");
		g_x11 = move_t_points[0];
		g_x12 = move_t_points[1];
		g_x13 = move_t_points[2];
		g_x22 = move_t_points[3];
		g_x23 = move_t_points[4];
		g_x33 = move_t_points[5];
		g_y1 = move_t_points[6];
		g_y2 = move_t_points[7];
		g_y3 = move_t_points[8];
	}
	printf("points = [%g, %g, %g, %g, %g, %g, %g, %g, %g]\n", g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3);
	printf("values = [%g, %g, %g, %g, %g, %g]\n", values[0], values[1], values[2], values[3], values[4], values[5]);
	printf("grad : "); gsl_vector_show(grad_v);
	printf("norm(grad): %f\n", gsl_blas_dnrm2(grad_v));
} while (status == GSL_CONTINUE && iter < SEARCH_MIN_ITER);
gsl_multimin_fdfminimizer_free(s);
gsl_vector_free(x);
}

double my_f(const gsl_vector *v, void *params)
{
extern double values[N_VALUES];
extern double g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3;
double o_x11, o_x12, o_x13, o_x22, o_x23, o_x33, o_y1, o_y2, o_y3;
double n_x11, n_x12, n_x13, n_x22, n_x23, n_x33, n_y1, n_y2, n_y3;
double val[N_VALUES];
int i;
for (i = 0; i < N_VALUES; i++)
	val[i] = values[i];
o_x11 = g_x11;
o_x12 = g_x12;
o_x13 = g_x13;
o_x22 = g_x22;
o_x23 = g_x23;
o_x33 = g_x33;
o_y1 = g_y1;
o_y2 = g_y2;
o_y3 = g_y3;
n_x11 = gsl_vector_get(v, 0);
n_x12 = gsl_vector_get(v, 1);
n_x13 = gsl_vector_get(v, 2);
n_x22 = gsl_vector_get(v, 3);
n_x23 = gsl_vector_get(v, 4);
n_x33 = gsl_vector_get(v, 5);
n_y1 = gsl_vector_get(v, 6);
n_y2 = gsl_vector_get(v, 7);
n_y3 = gsl_vector_get(v, 8);
#ifdef DEBUG_RK
printf("call my_f([%g, %g, %g, %g, %g, %g, %g, %g, %g])\n", n_x11, n_x12, n_x13, n_x22, n_x23, n_x33, n_y1, n_y2, n_y3);
#endif
move_t(g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3, n_x11, n_x12, n_x13, n_x22, n_x23, n_x33, n_y1, n_y2, n_y3, val);
g_x11 = o_x11;
g_x12 = o_x12;
g_x13 = o_x13;
g_x22 = o_x22;
g_x23 = o_x23;
g_x33 = o_x33;
g_y1 = o_y1;
g_y2 = o_y2;
g_y3 = o_y3;
return val[0];
}

void my_df(const gsl_vector *v, void *param, gsl_vector *df)
{
extern double g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3;
extern double values[N_VALUES];
extern gsl_vector *grad_v;

double x11, x12, x13, x22, x23, x33, y1, y2, y3;
x11 = gsl_vector_get(v, 0);
x12 = gsl_vector_get(v, 1);
x13 = gsl_vector_get(v, 2);
x22 = gsl_vector_get(v, 3);
x23 = gsl_vector_get(v, 4);
x33 = gsl_vector_get(v, 5);
y1 = gsl_vector_get(v, 6);
y2 = gsl_vector_get(v, 7);
y3 = gsl_vector_get(v, 8);
#ifdef DEBUG_RK
printf("call my_df([%g, %g, %g, %g, %g, %g, %g, %g, %g])\n", x11, x12, x13, x22, x23, x33, y1, y2, y3);
#endif

/* ÅÀ v ¤Ç¤Î´Ø¿ôÃÍ¤ò·×»» */
double o_x11, o_x12, o_x13, o_x22, o_x23, o_x33, o_y1, o_y2, o_y3;
double val[N_VALUES];
int i;

/* move_all ¤Ç¹¹¿·¤µ¤ì¤Æ¤·¤Þ¤¦¤Î¤Ç¡¢ g_* ¤ò¥³¥Ô¡¼  */
for (i = 0; i < N_VALUES; i++)
	val[i] = values[i];
o_x11 =g_x11;
o_x12 =g_x12;
o_x13 =g_x13;
o_x22 =g_x22;
o_x23 =g_x23;
o_x33 =g_x33;
o_y1 = g_y1;
o_y2 = g_y2;
o_y3 = g_y3;

move_t(g_x11, g_x12, g_x13, g_x22, g_x23, g_x33, g_y1, g_y2, g_y3, gsl_vector_get(v, 0), gsl_vector_get(v, 1), gsl_vector_get(v, 2), gsl_vector_get(v, 3), gsl_vector_get(v, 4), gsl_vector_get(v, 5), gsl_vector_get(v, 6), gsl_vector_get(v, 7), gsl_vector_get(v, 8), val);
/* g_* ¤ò¸µ¤ÎÃÍ¤ËÌá¤¹ */
g_x11 =o_x11;
g_x12 =o_x12;
g_x13 =o_x13;
g_x22 =o_x22;
g_x23 =o_x23;
g_x33 =o_x33;
g_y1 = o_y1;
g_y2 = o_y2;
g_y3 = o_y3;
grad(x11, x12, x13, x22, x23, x33, y1, y2, y3, 1, val);
for (i = 0; i < DIM; i++)
	gsl_vector_set(df, i, gsl_vector_get(grad_v, i));
}

void my_fdf(const gsl_vector *x, void *params, double *f, gsl_vector *df)
{
*f = my_f(x, params);
my_df(x, params, df);
}

void grad(double x11, double x12, double x13, double x22, double x23, double x33, double y1, double y2, double y3, double r, double *val)
{
extern gsl_vector *grad_v;
extern gsl_matrix *pf11_m, *pf12_m, *pf13_m, *pf22_m, *pf23_m, *pf33_m, *pf1_m, *pf2_m, *pf3_m;
int i;
double t;

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf11_m, 0, i) * val[i];
gsl_vector_set(grad_v, 0, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf12_m, 0, i) * val[i];
gsl_vector_set(grad_v, 1, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf13_m, 0, i) * val[i];
gsl_vector_set(grad_v, 2, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf22_m, 0, i) * val[i];
gsl_vector_set(grad_v, 3, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf23_m, 0, i) * val[i];
gsl_vector_set(grad_v, 4, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf33_m, 0, i) * val[i];
gsl_vector_set(grad_v, 5, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf1_m, 0, i) * val[i];
gsl_vector_set(grad_v, 6, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf2_m, 0, i) * val[i];
gsl_vector_set(grad_v, 7, t);

for (i = 0, t = 0; i < N_VALUES; i++)
	t += gsl_matrix_get(pf3_m, 0, i) * val[i];
gsl_vector_set(grad_v, 8, t);

}

void gsl_vector_show(gsl_vector *v)
{
int i;
for (i = 0; i < v->size; i++)
printf("%f ", gsl_vector_get(v, i));
printf("\n");
}

void show_v(double *v, int n)
{
int i;
printf("[");
for (i = 0; i < n; i++) {
printf("%g", v[i]);
if (i < n - 1)
printf(", ");
}
printf("]\n");
}

#define SMAX 1024
next(FILE *fp,char *s,char *msg) {
  s[0] = '%';
  while (s[0] == '%') {
        if (!fgets(s,SMAX,fp)) {
          fprintf(stderr,"Data format error at %s\n",msg);
          exit(-1);
        }
        if (s[0] != '%') return(0);
  }
}
setData(char *fname) {
  int rank;
  char s[SMAX];
  FILE *fp;
  int i;

  if ((fp=fopen(fname,"r")) == NULL) {
        fprintf(stderr,"File %s is not found.\n",fname);
        exit(-1);
  }

  next(fp,s,"g_s11");
  sscanf(s,"%lg",&g_s11);
  next(fp,s,"g_s12");
  sscanf(s,"%lg",&g_s12);
  next(fp,s,"g_s13");
  sscanf(s,"%lg",&g_s13);

  next(fp,s,"g_s22");
  sscanf(s,"%lg",&g_s22);
  next(fp,s,"g_s23");
  sscanf(s,"%lg",&g_s23);

  next(fp,s,"g_s33");
  sscanf(s,"%lg",&g_s33);

  next(fp,s,"g_s1");
  sscanf(s,"%lg",&g_s1);
  next(fp,s,"g_s2");
  sscanf(s,"%lg",&g_s2);
  next(fp,s,"g_s3");
  sscanf(s,"%lg",&g_s3);

  next(fp,s,"g_x11");
  sscanf(s,"%lg",&g_x11);
  next(fp,s,"g_x12");
  sscanf(s,"%lg",&g_x12);
  next(fp,s,"g_x13");
  sscanf(s,"%lg",&g_x13);

  next(fp,s,"g_x22");
  sscanf(s,"%lg",&g_x22);
  next(fp,s,"g_x23");
  sscanf(s,"%lg",&g_x23);

  next(fp,s,"g_x33");
  sscanf(s,"%lg",&g_x33);

  next(fp,s,"g_y1");
  sscanf(s,"%lg",&g_y1);
  next(fp,s,"g_y2");
  sscanf(s,"%lg",&g_y2);
  next(fp,s,"g_y3");
  sscanf(s,"%lg",&g_y3);

 next(fp,s,"g_r");
  sscanf(s,"%lg",&g_r);

  if (Verbose) {
  }
  fclose(fp);
}

